diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aarf-wifi-manager.h ns-3.31/src/wifi/model/aarf-wifi-manager.h
--- ns-3.30.1/src/wifi/model/aarf-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aarf-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -35,9 +35,9 @@
  * A Practical Approach</i>, by M. Lacage, M.H. Manshaei, and
  * T. Turletti.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class AarfWifiManager : public WifiRemoteStationManager
 {
@@ -61,19 +61,18 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
-  uint32_t m_minTimerThreshold; ///< minimum timer threshold
+  uint32_t m_minTimerThreshold;   ///< minimum timer threshold
   uint32_t m_minSuccessThreshold; ///< minimum success threshold
-  double m_successK; ///< Multiplication factor for the success threshold
+  double m_successK;              ///< Multiplication factor for the success threshold
   uint32_t m_maxSuccessThreshold; ///< maximum success threshold
-  double m_timerK; ///< Multiplication factor for the timer threshold
+  double m_timerK;                ///< Multiplication factor for the timer threshold
 
   TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/adhoc-wifi-mac.cc ns-3.31/src/wifi/model/adhoc-wifi-mac.cc
--- ns-3.30.1/src/wifi/model/adhoc-wifi-mac.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/adhoc-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -72,19 +72,15 @@
 }
 
 void
-AdhocWifiMac::Enqueue (Ptr<const Packet> packet, Mac48Address to)
+AdhocWifiMac::Enqueue (Ptr<Packet> packet, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << to);
   if (m_stationManager->IsBrandNew (to))
     {
-      //In ad hoc mode, we assume that every destination supports all
-      //the rates we support.
-      if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
-        {
-          m_stationManager->AddAllSupportedMcs (to);
-        }
+      //In ad hoc mode, we assume that every destination supports all the rates we support.
       if (GetHtSupported ())
         {
+          m_stationManager->AddAllSupportedMcs (to);
           m_stationManager->AddStationHtCapabilities (to, GetHtCapabilities ());
         }
       if (GetVhtSupported ())
@@ -137,9 +133,9 @@
       hdr.SetType (WIFI_MAC_DATA);
     }
 
-  if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
+  if (GetHtSupported ())
     {
-      hdr.SetNoOrder (); // explicitly set to 0 for the time being since HT/VHT/HE control field is not yet implemented (set it to 1 when implemented)
+      hdr.SetNoOrder (); // explicitly set to 0 for the time being since HT control field is not yet implemented (set it to 1 when implemented)
     }
   hdr.SetAddr1 (to);
   hdr.SetAddr2 (m_low->GetAddress ());
@@ -172,23 +168,19 @@
 }
 
 void
-AdhocWifiMac::Receive (Ptr<Packet> packet, const WifiMacHeader *hdr)
+AdhocWifiMac::Receive (Ptr<WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this << packet << hdr);
+  NS_LOG_FUNCTION (this << *mpdu);
+  const WifiMacHeader* hdr = &mpdu->GetHeader ();
   NS_ASSERT (!hdr->IsCtl ());
   Mac48Address from = hdr->GetAddr2 ();
   Mac48Address to = hdr->GetAddr1 ();
   if (m_stationManager->IsBrandNew (from))
     {
-      //In ad hoc mode, we assume that every destination supports all
-      //the rates we support.
-      if (GetHtSupported () || GetVhtSupported () || GetHeSupported ())
-        {
-          m_stationManager->AddAllSupportedMcs (from);
-          m_stationManager->AddStationHtCapabilities (from, GetHtCapabilities ());
-        }
+      //In ad hoc mode, we assume that every destination supports all the rates we support.
       if (GetHtSupported ())
         {
+          m_stationManager->AddAllSupportedMcs (from);
           m_stationManager->AddStationHtCapabilities (from, GetHtCapabilities ());
         }
       if (GetVhtSupported ())
@@ -207,11 +199,11 @@
       if (hdr->IsQosData () && hdr->IsQosAmsdu ())
         {
           NS_LOG_DEBUG ("Received A-MSDU from" << from);
-          DeaggregateAmsduAndForward (packet, hdr);
+          DeaggregateAmsduAndForward (mpdu);
         }
       else
         {
-          ForwardUp (packet, from, to);
+          ForwardUp (mpdu->GetPacket ()->Copy (), from, to);
         }
       return;
     }
@@ -219,7 +211,7 @@
   //Invoke the receive handler of our parent class to deal with any
   //other frames. Specifically, this will handle Block Ack-related
   //Management Action frames.
-  RegularWifiMac::Receive (packet, hdr);
+  RegularWifiMac::Receive (mpdu);
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/adhoc-wifi-mac.h ns-3.31/src/wifi/model/adhoc-wifi-mac.h
--- ns-3.30.1/src/wifi/model/adhoc-wifi-mac.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/adhoc-wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,7 +30,7 @@
 /**
  * \ingroup wifi
  *
- *
+ * \brief Wifi MAC high model for an ad-hoc Wifi MAC
  */
 class AdhocWifiMac : public RegularWifiMac
 {
@@ -44,29 +44,13 @@
   AdhocWifiMac ();
   virtual ~AdhocWifiMac ();
 
-  /**
-   * \param address the current address of this MAC layer.
-   */
+  // Implementations of pure virtual methods, or overridden from base class.
   void SetAddress (Mac48Address address);
-
-  /**
-   * \param linkUp the callback to invoke when the link becomes up.
-   */
   void SetLinkUpCallback (Callback<void> linkUp);
-
-  /**
-   * \param packet the packet to send.
-   * \param to the address to which the packet should be sent.
-   *
-   * The packet should be enqueued in a tx queue, and should be
-   * dequeued as soon as the channel access function determines that
-   * access is granted to this MAC.
-   */
-  void Enqueue (Ptr<const Packet> packet, Mac48Address to);
-
+  void Enqueue (Ptr<Packet> packet, Mac48Address to);
 
 private:
-  void Receive (Ptr<Packet> packet, const WifiMacHeader *hdr);
+  void Receive (Ptr<WifiMacQueueItem> mpdu);
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ampdu-subframe-header.h ns-3.31/src/wifi/model/ampdu-subframe-header.h
--- ns-3.30.1/src/wifi/model/ampdu-subframe-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ampdu-subframe-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,6 +27,7 @@
 
 /**
  * \ingroup wifi
+ * \brief Headers for A-MPDU subframes
  */
 class AmpduSubframeHeader : public Header
 {
@@ -49,19 +50,19 @@
   /**
    * Set the length field.
    *
-   * \param length
+   * \param length in bytes
    */
   void SetLength (uint16_t length);
   /**
   * Set the EOF field.
   *
-  * \param eof
+  * \param eof set EOF field if true
   */
   void SetEof (bool eof);
   /**
    * Return the length field.
    *
-   * \return the length field
+   * \return the length field in bytes
    */
   uint16_t GetLength (void) const;
   /**
@@ -80,7 +81,7 @@
   bool IsSignatureValid (void) const;
 
 private:
-  uint16_t m_length;   //!< length field
+  uint16_t m_length;   //!< length field in bytes
   bool m_eof;          //!< EOF field
   uint8_t m_signature; //!< delimiter signature (should correspond to pattern 0x4E in order to be assumed valid)
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ampdu-tag.cc ns-3.31/src/wifi/model/ampdu-tag.cc
--- ns-3.30.1/src/wifi/model/ampdu-tag.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ampdu-tag.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,9 +49,9 @@
 }
 
 void
-AmpduTag::SetRemainingNbOfMpdus (uint8_t nbofmpdus)
+AmpduTag::SetRemainingNbOfMpdus (uint8_t nbOfMpdus)
 {
-  m_nbOfMpdus = nbofmpdus;
+  m_nbOfMpdus = nbOfMpdus;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/ampdu-tag.h ns-3.31/src/wifi/model/ampdu-tag.h
--- ns-3.30.1/src/wifi/model/ampdu-tag.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/ampdu-tag.h	2020-06-27 17:38:30.000000000 -0700
@@ -44,15 +44,15 @@
   TypeId GetInstanceTypeId (void) const;
 
   /**
-   * Create a AmpduTag with the default =0 no Ampdu
+   * Create a AmpduTag with the default =0 no A-MPDU
    */
   AmpduTag ();
   /**
-   * \param nbofmpdus the remaining number of MPDUs
+   * \param nbOfMpdus the remaining number of MPDUs
    *
    * Set the remaining number of MPDUs in the A-MPDU.
    */
-  void SetRemainingNbOfMpdus (uint8_t nbofmpdus);
+  void SetRemainingNbOfMpdus (uint8_t nbOfMpdus);
   /**
    * \param duration the remaining duration of the A-MPDU
    *
@@ -81,7 +81,7 @@
 
 private:
   uint8_t m_nbOfMpdus; //!< Remaining number of MPDUs in the A-MPDU
-  Time m_duration;     //!< Remaining duration of the A-MPDU in nanoseconds
+  Time m_duration;     //!< Remaining duration of the A-MPDU
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/amrr-wifi-manager.cc ns-3.31/src/wifi/model/amrr-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/amrr-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/amrr-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,14 +38,14 @@
 struct AmrrWifiRemoteStation : public WifiRemoteStation
 {
   Time m_nextModeUpdate; ///< next mode update time
-  uint32_t m_tx_ok; ///< transmit ok
-  uint32_t m_tx_err; ///< transmit error
-  uint32_t m_tx_retr; ///< transmit retry
-  uint32_t m_retry; ///< retry
-  uint8_t m_txrate; ///< transmit rate
+  uint32_t m_tx_ok;      ///< transmit OK
+  uint32_t m_tx_err;     ///< transmit error
+  uint32_t m_tx_retr;    ///< transmit retry
+  uint32_t m_retry;      ///< retry
+  uint8_t m_txrate;      ///< transmit rate
   uint32_t m_successThreshold; ///< success threshold
-  uint32_t m_success; ///< success
-  bool m_recovery; ///< recovery
+  uint32_t m_success;    ///< success
+  bool m_recovery;       ///< recovery
 };
 
 
@@ -155,7 +155,7 @@
 AmrrWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AmrrWifiRemoteStation *station = (AmrrWifiRemoteStation *)st;
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
   station->m_retry++;
   station->m_tx_retr++;
 }
@@ -168,11 +168,11 @@
 }
 
 void
-AmrrWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                 double ackSnr, WifiMode ackMode, double dataSnr)
+AmrrWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  AmrrWifiRemoteStation *station = (AmrrWifiRemoteStation *)st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
   station->m_retry = 0;
   station->m_tx_ok++;
 }
@@ -187,7 +187,7 @@
 AmrrWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AmrrWifiRemoteStation *station = (AmrrWifiRemoteStation *)st;
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
   station->m_retry = 0;
   station->m_tx_err++;
 }
@@ -322,7 +322,7 @@
 AmrrWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AmrrWifiRemoteStation *station = (AmrrWifiRemoteStation *)st;
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
   UpdateMode (station);
   NS_ASSERT (station->m_txrate < GetNSupported (station));
   uint8_t rateIndex;
@@ -366,7 +366,6 @@
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, rateIndex);
@@ -382,11 +381,10 @@
 AmrrWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AmrrWifiRemoteStation *station = (AmrrWifiRemoteStation *)st;
+  AmrrWifiRemoteStation *station = static_cast<AmrrWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   UpdateMode (station);
@@ -404,10 +402,4 @@
   return rtsTxVector;
 }
 
-bool
-AmrrWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/amrr-wifi-manager.h ns-3.31/src/wifi/model/amrr-wifi-manager.h
--- ns-3.30.1/src/wifi/model/amrr-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/amrr-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -37,9 +37,9 @@
  * A Practical Approach</i>, by M. Lacage, M.H. Manshaei, and
  * T. Turletti.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class AmrrWifiManager : public WifiRemoteStationManager
 {
@@ -64,43 +64,42 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
   /**
    * Update the mode used to send to the given station.
    *
-   * \param station
+   * \param station the remote station state
    */
   void UpdateMode (AmrrWifiRemoteStation *station);
   /**
    * Reset transmission statistics of the given station.
    *
-   * \param station
+   * \param station the remote station state
    */
   void ResetCnt (AmrrWifiRemoteStation *station);
   /**
    * Increase the transmission rate to the given station.
    *
-   * \param station
+   * \param station the remote station state
    */
   void IncreaseRate (AmrrWifiRemoteStation *station);
   /**
    * Decrease the transmission rate to the given station.
    *
-   * \param station
+   * \param station the remote station state
    */
   void DecreaseRate (AmrrWifiRemoteStation *station);
   /**
    * Check if the current rate for the given station is the
    * minimum rate.
    *
-   * \param station
+   * \param station the remote station state
    *
    * \return true if the current rate is the minimum rate,
    *         false otherwise
@@ -110,7 +109,7 @@
    * Check if the current rate for the given station is the
    * maximum rate.
    *
-   * \param station
+   * \param station the remote station state
    *
    * \return true if the current rate is the maximum rate,
    *         false otherwise
@@ -120,7 +119,7 @@
    * Check if the number of retransmission and transmission error
    * is less than the number of successful transmission (times ratio).
    *
-   * \param station
+   * \param station the remote station state
    *
    * \return true if the number of retransmission and transmission error
    *              is less than the number of successful transmission
@@ -131,7 +130,7 @@
    * Check if the number of retransmission and transmission error
    * is greater than the number of successful transmission (times ratio).
    *
-   * \param station
+   * \param station the remote station state
    *
    * \return true if the number of retransmission and transmission error
    *              is less than the number of successful transmission
@@ -142,18 +141,18 @@
    * Check if the number of retransmission, transmission error,
    * and successful transmission are greater than 10.
    *
-   * \param station
+   * \param station the remote station state
    * \return true if the number of retransmission, transmission error,
    *         and successful transmission are greater than 10,
    *         false otherwise
    */
   bool IsEnough (AmrrWifiRemoteStation *station) const;
 
-  Time m_updatePeriod; ///< update period
-  double m_failureRatio; ///< failure ratio
-  double m_successRatio; ///< success ratio
+  Time m_updatePeriod;            ///< update period
+  double m_failureRatio;          ///< failure ratio
+  double m_successRatio;          ///< success ratio
   uint32_t m_maxSuccessThreshold; ///< maximum success threshold
-  uint32_t m_minSuccessThreshold; ///< mnimum success threshold
+  uint32_t m_minSuccessThreshold; ///< minimum success threshold
 
   TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/amsdu-subframe-header.h ns-3.31/src/wifi/model/amsdu-subframe-header.h
--- ns-3.30.1/src/wifi/model/amsdu-subframe-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/amsdu-subframe-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -28,6 +28,7 @@
 
 /**
  * \ingroup wifi
+ * \brief Headers for A-MSDU subframes
  */
 class AmsduSubframeHeader : public Header
 {
@@ -58,7 +59,7 @@
   void SetSourceAddr (Mac48Address to);
   /**
    * Set length function
-   * \param length the length
+   * \param length the length in bytes
    */
   void SetLength (uint16_t length);
   /**
@@ -73,14 +74,14 @@
   Mac48Address GetSourceAddr (void) const;
   /**
    * Get length function
-   * \returns the length
+   * \returns the length in bytes
    */
   uint16_t GetLength (void) const;
 
 private:
   Mac48Address m_da; ///< destination address
   Mac48Address m_sa; ///< source address
-  uint16_t m_length; ///< length
+  uint16_t m_length; ///< length in bytes
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aparf-wifi-manager.cc ns-3.31/src/wifi/model/aparf-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/aparf-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aparf-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -201,7 +201,7 @@
 void AparfWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AparfWifiRemoteStation *station = (AparfWifiRemoteStation *) st;
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_nFailed++;
   station->m_nSuccess = 0;
@@ -255,11 +255,11 @@
 }
 
 void
-AparfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr,
-                                  WifiMode ackMode, double dataSnr)
+AparfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                  double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  AparfWifiRemoteStation *station = (AparfWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_nSuccess++;
   station->m_nFailed = 0;
@@ -339,11 +339,10 @@
 AparfWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  AparfWifiRemoteStation *station = (AparfWifiRemoteStation *) st;
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   CheckInit (station);
@@ -369,13 +368,12 @@
 AparfWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  /// \todo we could/should implement the Arf algorithm for
+  /// \todo we could/should implement the ARF algorithm for
   /// RTS only by picking a single rate within the BasicRateSet.
-  AparfWifiRemoteStation *station = (AparfWifiRemoteStation *) st;
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -392,10 +390,4 @@
   return rtsTxVector;
 }
 
-bool
-AparfWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/aparf-wifi-manager.h ns-3.31/src/wifi/model/aparf-wifi-manager.h
--- ns-3.30.1/src/wifi/model/aparf-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/aparf-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -38,9 +38,9 @@
  * Networks, Springer, 2005, 12, 123-145.
  * http://www.cs.mun.ca/~yzchen/papers/papers/rate_adaptation/80211_dynamic_rate_power_adjustment_chevillat_j2005.pdf
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class AparfWifiManager : public WifiRemoteStationManager
 {
@@ -77,13 +77,12 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
   /** Check for initializations.
    *
@@ -97,8 +96,8 @@
   uint32_t m_powerMax;   //!< The maximum number of power changes.
   uint8_t m_powerInc;    //!< Step size for increment the power.
   uint8_t m_powerDec;    //!< Step size for decrement the power.
-  uint8_t m_rateInc;    //!< Step size for increment the rate.
-  uint8_t m_rateDec;    //!< Step size for decrement the rate.
+  uint8_t m_rateInc;     //!< Step size for increment the rate.
+  uint8_t m_rateDec;     //!< Step size for decrement the rate.
 
   /**
    * Minimal power level.
